/* 
 *  DOCSIS configuration file encoder. 
 *  Copyright (c) 2001 Cornel Ciocirlan, ctrl@users.sourceforge.net.
 *  Copyright (c) 2002 Evvolve Media SRL,office@evvolve.com
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  DOCSIS is a registered trademark of Cablelabs, http://www.cablelabs.com
 */

// #define DEBUG	1
// #define YYDEBUG 1

#ifndef _DOCSIS_SYMTABLE_H
#define _DOCSIS_SYMTABLE_H


typedef struct symbol_entry {
	unsigned int id;
	char sym_ident[30];
	unsigned char docsis_code;
	unsigned int parent_id;
	int (*encode_func) (unsigned char *, void *, struct symbol_entry *);
	void (*decode_func) (unsigned char *, struct symbol_entry *);
	unsigned int low_limit;
	unsigned int high_limit;
} symbol_type;



symbol_type *find_symbol_by_name(char *sym_str);

symbol_type *find_symbol_by_code_and_pid( unsigned char code, unsigned int pid );


#endif /* _DOCSIS_SYMTABLE_H */
