/* my_sql.h
 *
 * docsis_server
 *
 * Copyright (C) 2002 Access Communications
 *                    email docsis_guy@accesscomm.ca
 *
 * Designed for use with DOCSIS cable modems and hosts.
 * And for use with MySQL Database Server.
 *
 ********************************************************************
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


typedef struct sql_buf {
	char		*qbuf;
	int		len;
	struct sql_buf	*next;
} SQL_buf;



/**********************************************************************/
/* define a few constants */

/* #define	MAC_NOT_FOUND	0
   #define DOCSIS_MODEM	1
   #define CUST_PC		2
   #define REJECT_DEV	3
*/

#define MLOG_ERROR  1
#define MLOG_DHCP   3
#define MLOG_TFTP   4
#define MLOG_TIME   5
#define MLOG_LOG    6
#define MLOG_SYSLOG 6
#define MLOG_STATS  99

#define NET_TYPE_CM   1
#define NET_TYPE_CPE  2
#define NET_TYPE_MTA  3

#define OPT_IP     1
#define OPT_2IP    2
#define OPT_INT8   3
#define OPT_UINT8  4
#define OPT_INT16  5
#define OPT_UINT16 6
#define OPT_INT32  7
#define OPT_UINT32 8
#define OPT_CHAR   9
#define OPT_SUBOPT 10

#define CHECK_LOAD_NO 0
#define CHECK_LOAD_YES 1

#define FULLFLAG_seton    1
#define FULLFLAG_setoff   2
#define FULLFLAG_clearall 3

#define DHCP_LOG_TYPE		1
#define TFTP_LOG_TYPE		2
#define TFTP_DYNAMIC_LOG_TYPE	3
#define SYS_LOG_TYPE		4

/**********************************************************************/


void  InitSQLconnection();
void  CloseSQLconnection();

/* SQL DB routines */
void  my_syslog( const int priority, const char * fmt, ... );

/* Load Average Checker */
void  my_LoadChecker();


/*******************************************************************************************/
#ifdef DHCP_SERVER

void  my_dhcplog( int sending, dhcp_message *message );

int   my_findMAC( dhcp_message *message );

int   my_findIP( dhcp_message *message, int find_type );

void  my_getNewIP( dhcp_message *message );

ConfigOptsPtr my_Get_Opt( int opt_id );

int  my_Get_Net( dhcp_message *message );
int Verify_Vlan( dhcp_message *message );

void  my_WriteNewLease( dhcp_message *message );
void  my_UpdateLease( dhcp_message *message );
void  my_UpdateTime( dhcp_message *message );
void  my_DeleteLease( dhcp_message *message );

int   my_findAgent( dhcp_message *message );
void  my_UpdateAgent( dhcp_message *message );

#endif

/* Other dhcp prototypes */
void  my_Load_Nets( void );
void  my_DeleteOldestLease( int cmts_vlan, int days );
void  my_CountUnusedIP( int *unused, int *total, int cmts_vlan, u_int32_t cmts_ip );
void  my_CountOLDIP( int cmts_vlan, int *ip45, int *ip30, int *ip15 );
void  Print_Log_Entries( int log_type, int num_lines );
void  Log_Summerize( void );
void  my_flush_SQL( void );


/*******************************************************************************************/
#ifdef CF_GEN

// void  my_CONFIG_Load( void );
// int   gen_Config_File( u_int32_t ipaddr, u_int8_t *dst, u_int32_t maxsize );
// u_int32_t  my_ReverseNet_CM( u_int32_t ipaddr );

#endif

/*******************************************************************************************/
#ifdef BACKG

int   my_Check_New_Configs( char *messages, int pr_info );
void  encode_config_morsel( char *id, char *text, char *messages );

#endif
/*******************************************************************************************/
#ifdef TFTP_SERVER

void my_TFTPlog( char * fname, u_int32_t ipaddr );

int  add_Config_Item( u_int8_t *dst, u_int32_t idnum, u_int32_t maxsize );
void add_MIC_Item( u_int32_t *cm_mic, u_int32_t *cmts_mic );
int  Check_MIC_Item( u_int32_t *cm_mic, u_int32_t *cmts_mic );

void  my_CONFIG_Load( void );
int   gen_Config_File( u_int32_t ipaddr, u_int8_t *dst, u_int32_t maxsize );
u_int32_t  my_ReverseNet_CM( u_int32_t ipaddr );

#endif


/*******************************************************************************************/
#ifdef SYSLOG_SERVER

void my_LogSyslog( u_int32_t ipaddr, char * message );

#endif


/*******************************************************************************************/

void cv_mac2num( u_int64_t *b_mac, u_int8_t *chaddr );
void cv_macaddr( u_int8_t *chaddr, char *macaddr, int numbytes );
void cv_addrmac( u_int8_t *chaddr, char *macaddr, int numbytes );
void get_date_time( char **the_date, char **the_time );
void Save_SQL_Update( char *pref, char *qbuf, int checkLoad );
void Config_StressTest( void );


