#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <syslog.h>

#include "../src-mysql/my_sql.h"
#include "../src-config/config_file.h"

int main( int argc, char *argv[] ) {
	int	del_num, n, num_days, vlan_id;

	if (argc < 2) {
		printf( "usage: %s vlan_id [num_ips_to_delete] [num_days]\n", argv[0] );
		printf( "num_ips will default to 10\n" );
		printf( "num_days will default to 45\n" );
		exit(1);
	}
	vlan_id = atoi( argv[1] );

	del_num = 10;
	if (argc >= 3) {
		del_num = atoi( argv[2] );
	}

	num_days = 45;
	if (argc >= 4) {
		num_days = atoi( argv[3] );
	}

	ReadConfigFile();
	InitSQLconnection();

	printf( "Deleting %d old leases \n", del_num );

	my_syslog(LOG_WARNING, "Delete Old Leases num_del=%d num_days=%d", del_num, num_days );

	for( n=0; n < del_num; n++ ) {
		my_DeleteOldestLease( vlan_id, num_days );
		printf( "\n" );
	}

	exit(0);
}
