#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "../src-mysql/my_sql.h"
#include "../src-config/config_file.h"

int main( int argc, char *argv[] ) {
	int log_type = 0;
	int num_mess = 20;

	if (argc < 2) {
		printf( "usage: %s log_type [number of messages]\n", argv[0] );
		printf( "where log_type is either 'dhcp','dtftp','tftp' or 'sys'\n" );
		printf( "      and num of messages defaults to 20 \n" );
		exit(1);
	}

	if (strcmp(argv[1],"dhcp") == 0) log_type = DHCP_LOG_TYPE;
	if (strcmp(argv[1],"tftp") == 0) log_type = TFTP_LOG_TYPE;
	if (strcmp(argv[1],"dtftp") == 0) log_type = TFTP_DYNAMIC_LOG_TYPE;
	if (strcmp(argv[1],"sys") == 0)  log_type = SYS_LOG_TYPE;

	if (log_type == 0) {
		printf( "usage: %s log_type [number of messages]\n", argv[0] );
		printf( "where log_type is either 'dhcp','tftp' or 'sys'\n" );
		printf( "      and num of messages defaults to 20 \n" );
		exit(1);
	}

	if (argc >= 3) {
		num_mess = atoi( argv[2] );
		if (num_mess < 1 || num_mess > 1000) {
			printf( "usage: %s log_type [number of messages]\n", argv[0] );
			printf( "where log_type is either 'dhcp','tftp' or 'sys'\n" );
			printf( "      and num of messages no bigger than 1000 \n" );
			exit(1);
		}
	}

	ReadConfigFile();
	InitSQLconnection();

	Print_Log_Entries( log_type, num_mess );

	exit(0);
}
